BAUD	EQU	$2B		;serial baud register
SCCR1	EQU	$2C		;serial control register 1
SCCR2	EQU	$2D		;serial control register 2
SCSR	EQU	$2E		;serial status register
SCDR	EQU	$2F		;serial tx/rx data register

TDRE	EQU	$80		Transmit Data Register Empty
RDRF	EQU	$20		Receive Data Register Full

	ORG	$0000		;RAM

	ORG	$B600		;EEPROM

	LDS	#$00C3		;Set up stack
	
	LDX	#$1000		Set up the register base
	
	CLR	SCCR1,X		9600/8/N/1/TE/RE
	LDD	#$300C
	STAA	BAUD,X
	STAB	SCCR2,X
	
MAIN	EQU	*
	BRCLR	SCSR,X RDRF *	Wait for a character to arrive
	LDAA	SCDR,X		Get the byte
	BRCLR	SCSR,X TDRE *	Wait for transmit register to empty
	STAA	SCDR,X		Echo it back
	BRA	MAIN		... and keep doing it

