**************************************
*               EQUATES              *
**************************************

BAUD	EQU	$2B		Serial baud register
SCCR1	EQU	$2C		Serial control register 1
SCCR2	EQU	$2D		Serial control register 2
SCSR	EQU	$2E		Serial status register
SCDR	EQU	$2F		Serial data register

TDRE	EQU	$80		Transmit Data Register Empty
RDRF	EQU	$20		Receive Data Register Full

	ORG	$0000		Start variables in RAM

	ORG	$F800		Prog starts in EEPROM

	LDS	#$00FF		Set up stack
	LDX	#$1000		Set up the register base

	CLR	SCCR1,X		1200/8/N/1/TE/RE
	LDD	#$300C
	STAA	BAUD,X
	STAB	SCCR2,X
	
	
MAIN	EQU	*		Start the main code block
	BRCLR	SCSR,X #RDRF *	Wait for a character to arrive
	LDAA	SCDR,X		Get the byte
	BRCLR	SCSR,X #TDRE *	Wait for transmit register to empty
	STAA	SCDR,X		Echo it back
	BRA	MAIN		... and keep doing it
	
******************************
* Interrupt Service Routines *
******************************
	
IRQ_RET	EQU	*		Dummy interrupt service routine
	RTI			Return

**************************************
* Interrupt Vector jump table
**************************************

	ORG	$FFD6
		FDB	IRQ_RET 	SCI
		FDB	IRQ_RET 	SPI
		FDB	IRQ_RET 	PACIE
		FDB	IRQ_RET 	PACO
		FDB	IRQ_RET 	TO
		FDB	IRQ_RET 	TOC5
		FDB	IRQ_RET 	TOC4
		FDB	IRQ_RET 	TOC3
		FDB	IRQ_RET 	TOC2
		FDB	IRQ_RET 	TOC1
		FDB	IRQ_RET 	IC3
		FDB	IRQ_RET 	IC2
		FDB	IRQ_RET 	IC1
		FDB	IRQ_RET 	RTI
		FDB	IRQ_RET 	IRQ
		FDB	IRQ_RET 	XIRQ
		FDB	IRQ_RET 	SWI
		FDB	IRQ_RET 	IOP
		FDB	IRQ_RET 	COPF
		FDB	IRQ_RET 	CMON
		FDB	$F800		RESET
.END
